package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.ClassInfo;
import com.openedge.core.metadata.EventInfo;
import com.openedge.core.metadata.MethodInfo;
import com.openedge.core.metadata.OOABLProperty;
import com.openedge.core.metadata.Constructor;
import com.openedge.core.metadata.Destructor;
import com.openedge.core.metadata.Field;
import java.util.*;

public class CustomClassTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomClassTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomClassTemplate result = new CustomClassTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/**********************************************************************" + NL + " * Copyright (C) 2006-2015 by Consultingwerk Ltd. (\"CW\") -            *" + NL + " * www.consultingwerk.de and other contributors as listed             *" + NL + " * below.  All Rights Reserved.                                       *" + NL + " *                                                                    *" + NL + " *  Software is distributed on an \"AS IS\", WITHOUT WARRANTY OF ANY    *" + NL + " *   KIND, either express or implied.                                 *" + NL + " *                                                                    *" + NL + " *  Contributors:                                                     *" + NL + " *                                                                    *" + NL + " **********************************************************************/" + NL + "/*------------------------------------------------------------------------" + NL + "    File        : ";
  protected final String TEXT_2 = NL + "    Purpose     : ";
  protected final String TEXT_3 = NL + "    Syntax      : " + NL + "    Description : ";
  protected final String TEXT_4 = NL + "    Author(s)   : ";
  protected final String TEXT_5 = NL + "    Created     : ";
  protected final String TEXT_6 = NL + "    Notes       : " + NL + "  ----------------------------------------------------------------------*/" + NL;
  protected final String TEXT_7 = NL;
  protected final String TEXT_8 = NL;
  protected final String TEXT_9 = NL;
  protected final String TEXT_10 = "USING ";
  protected final String TEXT_11 = ".* FROM PROPATH .  " + NL + "USING Progress.Lang.* FROM PROPATH .";
  protected final String TEXT_12 = NL;
  protected final String TEXT_13 = NL + "CLASS ";
  protected final String TEXT_14 = " IMPLEMENTS ";
  protected final String TEXT_15 = ", ";
  protected final String TEXT_16 = " USE-WIDGET-POOL";
  protected final String TEXT_17 = " FINAL";
  protected final String TEXT_18 = " ABSTRACT";
  protected final String TEXT_19 = " ";
  protected final String TEXT_20 = NL;
  protected final String TEXT_21 = NL;
  protected final String TEXT_22 = NL;
  protected final String TEXT_23 = NL;
  protected final String TEXT_24 = NL;
  protected final String TEXT_25 = NL;
  protected final String TEXT_26 = " " + NL;
  protected final String TEXT_27 = NL + "END CLASS.";
  protected final String TEXT_28 = NL;

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	ClassInfo data = (ClassInfo) argument.getObj("wizardinfo");

	Set events = data.getEvents();
	List methods = data.getMethods();
	Set properties = data.getProperties();
	Set fields = data.getFields();
	Set constructors = data.getConstructors();
	Destructor destructor = data.getDestructor();
	boolean ldAtBeginning = true;
	boolean ldAtEnd = true;
	boolean lIsEnum = (data.getSuperClassName().equals("Consultingwerk.Enum"));
	boolean lIsJsonSerializable = (data.getSuperClassName().equals("Consultingwerk.JsonSerializable"));
 
    stringBuffer.append(TEXT_1);
    stringBuffer.append( data.getClassName() );
    stringBuffer.append(TEXT_2);
    stringBuffer.append( data.getPurpose() );
    stringBuffer.append(TEXT_3);
    stringBuffer.append( data.getDescription() );
    stringBuffer.append(TEXT_4);
    stringBuffer.append( System.getProperty("user.name") );
    stringBuffer.append(TEXT_5);
    stringBuffer.append( new java.util.Date(System.currentTimeMillis()) );
    stringBuffer.append(TEXT_6);
    stringBuffer.append(TEXT_7);
    stringBuffer.append( OETemplateUtil.generateRoutineLevelThrowStatement() );
    stringBuffer.append(TEXT_8);
    stringBuffer.append( lIsJsonSerializable ? NL + "{Consultingwerk/products.i}" + NL : "" );
    stringBuffer.append(TEXT_9);
    stringBuffer.append(OETemplateUtil.genearateUsingStatements(data.isInherited(), data.getSuperClassName(), data.isImplements(), data.getInterfaceNames(), NL));
    stringBuffer.append( lIsEnum ? "USING Consultingwerk.Framework.Collections.* FROM PROPATH ." + NL : "" );
    stringBuffer.append( lIsJsonSerializable ? "USING Consultingwerk.* FROM PROPATH ." + NL : "" );
    stringBuffer.append(TEXT_10);
    stringBuffer.append( data.getPackageName() );
    stringBuffer.append(TEXT_11);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(OETemplateUtil.generateAnnotations(data.getAnnotations(), NL));
    stringBuffer.append(TEXT_13);
    stringBuffer.append(data.getQualifiedName() );
    stringBuffer.append(data.isInherited() && lIsJsonSerializable == false ?" INHERITS "+OETemplateUtil.getClassName(data.getSuperClassName()):"");
     if(data.isImplements()) { java.util.Iterator iterator = data.getInterfaceNames().iterator(); 
    stringBuffer.append(TEXT_14);
     while(iterator.hasNext()) {
    stringBuffer.append(OETemplateUtil.getClassName(iterator.next().toString()));
    if(iterator.hasNext())
    stringBuffer.append(TEXT_15);
    }}
    if(data.isUseWidgetPool()) {
    stringBuffer.append(TEXT_16);
    }
    if(data.isFinal()) {
    stringBuffer.append(TEXT_17);
    }
    if(data.isAbstract()) {
    stringBuffer.append(TEXT_18);
    }
    stringBuffer.append( lIsJsonSerializable == false ? ":" : "" );
    stringBuffer.append(TEXT_19);
    stringBuffer.append(TEXT_20);
    stringBuffer.append( lIsJsonSerializable ? "&IF '{&FrameworkSerializationType}' EQ 'XML' OR PROVERSION BEGINS '10.2':U &THEN" + NL + "    INHERITS XmlSerializable" + NL + "&ELSE" + NL + "    INHERITS JsonSerializable" + NL + "&ENDIF" + NL + "    {&SERIALIZABLE}:" : "" );
    stringBuffer.append(TEXT_21);
    stringBuffer.append( lIsEnum ? "    {Consultingwerk/EnumMember.i FirstValue 0 " + data.getClassName() + "}" + NL + NL + "    /*------------------------------------------------------------------------------" + NL + "        Purpose: Constructor for the " + data.getClassName() + " members" + NL +                                                                "        Notes:" + NL +                                             "        @param piValue The internal (numeric) representation of the Enumeration member" + NL + "        @param pcLabel The text label of the Enumaration member" + NL +                               "    ------------------------------------------------------------------------------*/" + NL + "    CONSTRUCTOR PRIVATE " + data.getClassName() + " (piValue AS INTEGER, pcLabel AS CHARACTER):" + NL + "        SUPER ()." + NL + " " + NL +          "        ASSIGN THIS-OBJECT:Value = piValue" + NL + "               THIS-OBJECT:Label = pcLabel ." + NL + " " + NL + "    END CONSTRUCTOR." + NL : "" );
    stringBuffer.append(TEXT_22);
    stringBuffer.append( lIsEnum ? "    /*------------------------------------------------------------------------------" + NL : "" );
    stringBuffer.append( lIsEnum ? "        Purpose: Returns a CharacterList with the names of the Enum members" + NL : "" );
    stringBuffer.append( lIsEnum ? "        Notes:   " + NL : "" );
    stringBuffer.append( lIsEnum ? "        @return The CharacterList with the names of the Enum members" + NL : "" );
    stringBuffer.append( lIsEnum ? "    ------------------------------------------------------------------------------*/" + NL : "" );
    stringBuffer.append( lIsEnum ? "    METHOD PUBLIC STATIC CharacterList GetNames ():" + NL : "" );
    stringBuffer.append( lIsEnum ? " " + NL : "" );
    stringBuffer.append( lIsEnum ? "        DEFINE VARIABLE oReturn AS CharacterList NO-UNDO . " + NL : "" );
    stringBuffer.append( lIsEnum ? " " + NL : "" );
    stringBuffer.append( lIsEnum ? "        RETURN NEW CharacterList ('{&EnumMembers}':U)." + NL : "" );
    stringBuffer.append( lIsEnum ? " " + NL : "" );
    stringBuffer.append( lIsEnum ? "    END METHOD ." + NL : "" );
    stringBuffer.append( lIsEnum ? "	" : "" );
    stringBuffer.append(TEXT_23);
    stringBuffer.append( lIsEnum ? "    {Consultingwerk/EnumFromString.i " + data.getQualifiedName () + "} " + NL : "" );
    stringBuffer.append(TEXT_24);
    stringBuffer.append(TEXT_25);
    stringBuffer.append( lIsJsonSerializable ? "    {Consultingwerk/JsonSerializableProperty.i PropertyName CHARACTER} ." + NL + NL + "    /*------------------------------------------------------------------------------" + NL + "        Purpose: Constructor for the " + data.getClassName() + " class" + NL + "        Notes:" + NL + "    ------------------------------------------------------------------------------*/" + NL + "    CONSTRUCTOR PUBLIC " + data.getClassName() + " ():" + NL + "        SUPER ()." + NL + "        THIS-OBJECT:AddSerializableProperties ('{&SerializableProperties}':U) ." + NL + NL + "    END CONSTRUCTOR.": "" );
    stringBuffer.append(TEXT_26);
    
	for (Iterator iter = fields.iterator(); iter.hasNext();) {
		Field field = (Field) iter.next();
    stringBuffer.append(OETemplateUtil.generateField(field, NL));
    	ldAtBeginning = false;
	} 
    
	ldAtBeginning = true;
	for (Iterator iter = events.iterator(); iter.hasNext();) {
		EventInfo event = (EventInfo) iter.next();
    stringBuffer.append(OETemplateUtil.generateEvent(event, NL, ldAtBeginning, ldAtEnd));
    	ldAtBeginning = false;
	} 
    
	ldAtBeginning = true;
	for (Iterator iter = properties.iterator(); iter.hasNext();) {
		OOABLProperty property = (OOABLProperty) iter.next();
    stringBuffer.append( NL );
    stringBuffer.append(OETemplateUtil.generateProperty(property, NL));
    stringBuffer.append( NL );
    		ldAtBeginning = false;
	} 
    stringBuffer.append(data.isGenerateConstructor()? OETemplateUtil.generateDefaultConstructor(data.getClassName(), NL):"");
    
	ldAtBeginning = true;
	for (Iterator iter = constructors.iterator(); iter.hasNext();) {
		Constructor constructor = (Constructor) iter.next();
    stringBuffer.append(OETemplateUtil.generateConstructor(constructor, NL));
    	ldAtBeginning = false;	
	} 
    
	ldAtBeginning = true;
	for (Iterator iter = methods.iterator(); iter.hasNext();) {
		MethodInfo method = (MethodInfo) iter.next();
    stringBuffer.append( NL );
    stringBuffer.append(OETemplateUtil.generateMethod(method, NL));
    stringBuffer.append( NL );
    	ldAtBeginning = false;
	} 
    stringBuffer.append(data.isGenerateDestructor() && destructor != null ? OETemplateUtil.generateDestructor(destructor, NL):"");
    stringBuffer.append(data.isGenerateDestructor() && destructor == null ? OETemplateUtil.generateDefaultDestructor(data.getClassName(), NL):"");
    stringBuffer.append(TEXT_27);
    stringBuffer.append(TEXT_28);
    return stringBuffer.toString();
  }
}