package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.DataTypes;
import com.openedge.core.metadata.Constructor;
import com.openedge.core.metadata.Mode;
import com.openedge.core.reflect.IParameter;
import com.openedge.pdt.text.OEutil;

public class CustomConstructorTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomConstructorTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomConstructorTemplate result = new CustomConstructorTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "  ";
  protected final String TEXT_2 = "\tCONSTRUCTOR ";
  protected final String TEXT_3 = " ";
  protected final String TEXT_4 = " (";
  protected final String TEXT_5 = "):" + NL + "\t\t";
  protected final String TEXT_6 = NL + "\t\t";
  protected final String TEXT_7 = NL + "\tEND CONSTRUCTOR." + NL;

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	Constructor constructorInfo = (Constructor) argument.getObj("constructorinfo");
	boolean addsuper = constructorInfo.isCallSuper();
	Object gencomments = argument.getObj("generatecomments");
	boolean generateComments = false;
	if (gencomments != null)
		generateComments = ((Boolean) gencomments).booleanValue();	
	StringBuffer paramsBuf = new StringBuffer();
	StringBuffer superBuf = new StringBuffer();
	IParameter[] parameter = constructorInfo.getParameters(); 
	for (int i = 0; i < parameter.length; i++) {
		String parameterText = OETemplateUtil.generateParameter(parameter[i],NL);		
		if (paramsBuf.length() > 0) {
			paramsBuf.append(", ");
		}
		paramsBuf.append(parameterText);
		String dataType = parameter[i].getDataType();
		String name = parameter[i].getName();
		if (OEutil.isReservedKeyword(name)){
			name = name + "0";
		} 
		if ("BUFFER".equalsIgnoreCase(dataType)) {
			// no mode for buffer
			superBuf.append(dataType + " " + name +(i<parameter.length-1?", " : ""));
		} else if (OETemplateUtil.isTableDatasetParameterType(parameter[i].getParameterType())) {
			if (DataTypes.HANDLE.getABLName(true).equalsIgnoreCase(dataType)){
				superBuf.append(parameter[i].getMode()+" "+ parameter[i].getParameterType().getName() + "-HANDLE " + name +(i<parameter.length-1?", " : ""));
			} else {
				superBuf.append(parameter[i].getMode()+" "+ parameter[i].getParameterType().getName() + " " + name +(i<parameter.length-1?", " : ""));
			}
		} else {
			superBuf.append(parameter[i].getMode()+" "+ name +(i<parameter.length-1?", " : ""));
		}
	}

     if(generateComments){
    stringBuffer.append(TemplateHelper.GenerateConstructorComment (constructorInfo.getName(), NL));
    stringBuffer.append( NL );
    }
     if(constructorInfo.getAnnotations().size()>0){
    stringBuffer.append(TEXT_1);
    stringBuffer.append(OETemplateUtil.generateAnnotations(constructorInfo.getAnnotations(), NL));
    stringBuffer.append( NL );
    }
    stringBuffer.append(TEXT_2);
    stringBuffer.append( constructorInfo.isStatic()? "STATIC" : Mode.ACESSORS[constructorInfo.getMode()]);
    stringBuffer.append(TEXT_3);
    stringBuffer.append( constructorInfo.getName() );
    stringBuffer.append(TEXT_4);
    stringBuffer.append( paramsBuf.toString() );
    stringBuffer.append(TEXT_5);
    stringBuffer.append(addsuper ? "SUPER (" + superBuf.toString() + ")." : "" );
    stringBuffer.append(TEXT_6);
    stringBuffer.append(constructorInfo.getMethodCode());
    stringBuffer.append(constructorInfo.isInsertCatch() ? OETemplateUtil.generateCatchBlock(NL) : "" );
    stringBuffer.append(constructorInfo.isInsertFinally()? OETemplateUtil.generateFinallyBlock(NL) : "");
    stringBuffer.append(TEXT_7);
     
    return stringBuffer.toString();
  }
}