package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.Destructor;

public class CustomDestructorTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomDestructorTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomDestructorTemplate result = new CustomDestructorTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + "    /*------------------------------------------------------------------------------" + NL + "        Purpose: Destructor for the ";
  protected final String TEXT_2 = " class " + NL + "        Notes:   " + NL + "    ------------------------------------------------------------------------------*/" + NL + "    DESTRUCTOR PUBLIC ";
  protected final String TEXT_3 = " ():" + NL + "" + NL + "    END DESTRUCTOR .";
  protected final String TEXT_4 = NL;

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    

     Destructor destructor = (Destructor) argument.getObj("destructor");
     String className = (String) argument.get("class");
     if (destructor != null) {
        className = destructor.getName();
     }     
     

    stringBuffer.append(TEXT_1);
    stringBuffer.append( className );
    stringBuffer.append(TEXT_2);
    stringBuffer.append( className );
    stringBuffer.append(TEXT_3);
    stringBuffer.append(TEXT_4);
    return stringBuffer.toString();
  }
}