package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.InterfaceInfo;

public class CustomInterfaceTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomInterfaceTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomInterfaceTemplate result = new CustomInterfaceTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/**********************************************************************" + NL + " * Copyright (C) 2006-2015 by Consultingwerk Ltd. (\"CW\") -            *" + NL + " * www.consultingwerk.de and other contributors as listed             *" + NL + " * below.  All Rights Reserved.                                       *" + NL + " *                                                                    *" + NL + " *  Software is distributed on an \"AS IS\", WITHOUT WARRANTY OF ANY    *" + NL + " *   KIND, either express or implied.                                 *" + NL + " *                                                                    *" + NL + " *  Contributors:                                                     *" + NL + " *                                                                    *" + NL + " **********************************************************************/" + NL + "/*------------------------------------------------------------------------" + NL + "    File        : ";
  protected final String TEXT_2 = NL + "    Purpose     : ";
  protected final String TEXT_3 = NL + "    Syntax      : " + NL + "    Description : ";
  protected final String TEXT_4 = NL + "    Author(s)   : ";
  protected final String TEXT_5 = NL + "    Created     : ";
  protected final String TEXT_6 = NL + "    Notes       : " + NL + "  ----------------------------------------------------------------------*/" + NL + "" + NL + "USING ";
  protected final String TEXT_7 = ".* FROM PROPATH .  " + NL + "USING Progress.Lang.* FROM PROPATH." + NL + "" + NL + "INTERFACE ";
  protected final String TEXT_8 = ":  " + NL + "  " + NL + "END INTERFACE.";

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    	InterfaceInfo data = (InterfaceInfo) argument.getObj("wizardinfo"); 
    stringBuffer.append(TEXT_1);
    stringBuffer.append( data.getClassName() );
    stringBuffer.append(TEXT_2);
    stringBuffer.append( data.getPurpose() );
    stringBuffer.append(TEXT_3);
    stringBuffer.append( data.getDescription() );
    stringBuffer.append(TEXT_4);
    stringBuffer.append( System.getProperty("user.name") );
    stringBuffer.append(TEXT_5);
    stringBuffer.append( new java.util.Date(System.currentTimeMillis()) );
    stringBuffer.append(TEXT_6);
    stringBuffer.append( data.getPackageName() );
    stringBuffer.append(TEXT_7);
    stringBuffer.append( data.getQualifiedName() );
    stringBuffer.append(TEXT_8);
    return stringBuffer.toString();
  }
}