package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.MethodInfo;
import com.openedge.core.metadata.Mode;
import com.openedge.core.reflect.IParameter;

public class CustomMethodTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomMethodTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomMethodTemplate result = new CustomMethodTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "\t";
  protected final String TEXT_2 = "\tMETHOD";
  protected final String TEXT_3 = " ";
  protected final String TEXT_4 = " ";
  protected final String TEXT_5 = " ";
  protected final String TEXT_6 = " (";
  protected final String TEXT_7 = ")";
  protected final String TEXT_8 = NL + "\t\t";
  protected final String TEXT_9 = NL + "\tEND METHOD .";

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	boolean generateComments = ((Boolean) argument.getObj("generatecomments")).booleanValue();
	boolean generateBody = ((Boolean) argument.getObj("generatebody")).booleanValue();
	MethodInfo methodInfo = (MethodInfo) argument.getObj("methodinfo");
	String returnType = methodInfo.getReturnType();
	StringBuilder returnBuf = new StringBuilder();
	if (returnType != null && (returnType.indexOf('[') > 0 || returnType.indexOf('<') > 0)) {
		returnBuf.append("\"");
	}
	returnBuf.append(returnType);
	if (returnType != null && (returnType.indexOf('[') > 0 || returnType.indexOf('<') > 0)) {
		returnBuf.append("\"");
	}
	
	StringBuilder paramsBuf = new StringBuilder();
	IParameter[] parameter = methodInfo.getParameters(); 
	for (int i = 0; i < parameter.length; i++) {
		String parameterText = OETemplateUtil.generateParameter(parameter[i],NL);		
		if (paramsBuf.length() > 0) {
			paramsBuf.append(", ");
		}
		paramsBuf.append(parameterText);		
	}

     if(generateComments){
    stringBuffer.append(TemplateHelper.GenerateComment(NL));
    stringBuffer.append( NL );
    }
     if(methodInfo.getAnnotations().size()>0){
    stringBuffer.append(TEXT_1);
    stringBuffer.append(OETemplateUtil.generateAnnotations(methodInfo.getAnnotations(), NL));
    stringBuffer.append( NL );
    }
    stringBuffer.append(TEXT_2);
    stringBuffer.append( methodInfo.isOverride() ? " OVERRIDE" :"");
    stringBuffer.append(TEXT_3);
    stringBuffer.append(Mode.ACESSORS[methodInfo.getMode()]);
    stringBuffer.append(methodInfo.isStatic() ? " STATIC":"");
    stringBuffer.append(methodInfo.isFinal() ? " FINAL":"");
    stringBuffer.append(methodInfo.isAbstract() ? " ABSTRACT":"");
    stringBuffer.append(TEXT_4);
    stringBuffer.append( returnBuf.toString() );
    stringBuffer.append( (methodInfo.getExtent() != 0) ? " EXTENT" : "" );
    stringBuffer.append( (methodInfo.getExtent() > 0) ? " " + String.valueOf(methodInfo.getExtent()) : "" );
    stringBuffer.append(TEXT_5);
    stringBuffer.append( methodInfo.getName() );
    stringBuffer.append(TEXT_6);
    stringBuffer.append( paramsBuf.toString() );
    stringBuffer.append(TEXT_7);
    stringBuffer.append(generateBody && !methodInfo.isAbstract() ? ":" : "." );
    if (generateBody && !methodInfo.isAbstract()) {
    stringBuffer.append(TEXT_8);
    stringBuffer.append(OETemplateUtil.generateMethodContents(methodInfo.isGenerateImplementation(), methodInfo, NL, methodInfo.getExtent()).replace("UNDO, THROW NEW Progress.Lang.AppError(\"METHOD NOT IMPLEMENTED\").", "UNDO, THROW NEW Consultingwerk.Exceptions.NotImplementedException (PROGRAM-NAME (1)) ."));
    stringBuffer.append(methodInfo.isGenerateCatch() ? OETemplateUtil.generateCatchBlock(NL) : "");
    stringBuffer.append(methodInfo.isGenerateFinally() ? OETemplateUtil.generateFinallyBlock(NL) : "");
    stringBuffer.append(TEXT_9);
    }
    return stringBuffer.toString();
  }
}