package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import java.util.*;

public class CustomProcedure implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomProcedure create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomProcedure result = new CustomProcedure();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "/**********************************************************************" + NL + " * Copyright (C) 2006-2015 by Consultingwerk Ltd. (\"CW\") -            *" + NL + " * www.consultingwerk.de and other contributors as listed             *" + NL + " * below.  All Rights Reserved.                                       *" + NL + " *                                                                    *" + NL + " *  Software is distributed on an \"AS IS\", WITHOUT WARRANTY OF ANY    *" + NL + " *   KIND, either express or implied.                                 *" + NL + " *                                                                    *" + NL + " *  Contributors:                                                     *" + NL + " *                                                                    *" + NL + " **********************************************************************/" + NL + "/*------------------------------------------------------------------------" + NL + "    File        : ";
  protected final String TEXT_2 = NL + "    Purpose     : ";
  protected final String TEXT_3 = NL + NL + "    Syntax      :" + NL + "" + NL + "    Description : ";
  protected final String TEXT_4 = NL + NL + "    Author(s)   : ";
  protected final String TEXT_5 = NL + "    Created     : ";
  protected final String TEXT_6 = NL + "    Notes       :" + NL + "  ----------------------------------------------------------------------*/" + NL + "" + NL + "/* ***************************  Definitions  ************************** */" + NL;
  protected final String TEXT_7 = NL;
  protected final String TEXT_8 = NL + NL + "/* ***************************  Main Block  *************************** */";
  protected final String TEXT_9 = NL;

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	String fileName = argument.get("%%NewFile_Filename%%");
	String purpose = argument.get("%%NewFile_Purpose%%");
	String description = argument.get("%%NewFile_Description%%");
	String author = argument.get("%%NewFile_Author%%");
	boolean isRoutineLevel = Boolean.valueOf(argument.get("RoutineLevel"));
	String dt = new Date().toString();

    stringBuffer.append(TEXT_1);
    stringBuffer.append( fileName );
    stringBuffer.append(TEXT_2);
    stringBuffer.append( purpose );
    stringBuffer.append(TEXT_3);
    stringBuffer.append( description );
    stringBuffer.append(TEXT_4);
    stringBuffer.append( author );
    stringBuffer.append(TEXT_5);
    stringBuffer.append( dt );
    stringBuffer.append(TEXT_6);
    stringBuffer.append(TEXT_7);
    stringBuffer.append( isRoutineLevel ? OETemplateUtil.generateRoutineLevelThrowStatement() : "" );
    stringBuffer.append(TEXT_8);
    stringBuffer.append(TEXT_9);
    return stringBuffer.toString();
  }
}