package de.consultingwerk.ide.templates;

import com.openedge.pdt.core.template.ITemplateGenerator;
import com.openedge.pdt.core.template.TemplateGenerationException;
import com.openedge.pdt.text.template.OETemplateUtil;
import com.openedge.pdt.core.template.ITemplateArgs;
import de.consultingwerk.ide.TemplateHelper;

import com.openedge.core.metadata.OOABLProperty;
import com.openedge.core.metadata.ReferenceProperty;
import com.openedge.core.metadata.DataTypeProperty;
import com.openedge.core.metadata.Mode;
import com.openedge.pdt.text.preferences.OEPreferences;
import com.openedge.core.metadata.OOABLUtil;

public class CustomPropertyTemplate implements ITemplateGenerator
 {
  protected static String nl;
  public static synchronized CustomPropertyTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    CustomPropertyTemplate result = new CustomPropertyTemplate();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "\tDEFINE ";
  protected final String TEXT_2 = " PROPERTY ";
  protected final String TEXT_3 = " AS ";
  protected final String TEXT_4 = " ";
  protected final String TEXT_5 = " ";
  protected final String TEXT_6 = " AS ";
  protected final String TEXT_7 = " ";
  protected final String TEXT_8 = NL + "\t";
  protected final String TEXT_9 = "GET(";
  protected final String TEXT_10 = "):" + NL + "\t\t";
  protected final String TEXT_11 = NL + "\tEND GET." + NL + "\t";
  protected final String TEXT_12 = "GET." + NL + "\t";
  protected final String TEXT_13 = "SET(INPUT arg AS ";
  protected final String TEXT_14 = "):" + NL + "\t\t";
  protected final String TEXT_15 = "\t\t" + NL + "\tEND SET." + NL + "\t";
  protected final String TEXT_16 = "SET.";
  protected final String TEXT_17 = " " + NL + "\tSET.";
  protected final String TEXT_18 = " ";

/* (non-javadoc)
    * @see ITemplateGenerator#generate(Object)
    */
public String generate(ITemplateArgs argument) throws TemplateGenerationException
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
    OOABLProperty data = (OOABLProperty) argument.getObj("propertyinfo");
    boolean generateComments = true; // ((Boolean) argument.getObj("generatecomments")).booleanValue();
    ReferenceProperty refProperty = null;
    DataTypeProperty dataTypeProperty = null;
 	if (data instanceof ReferenceProperty) 
		 refProperty = (ReferenceProperty) data; 
	if (data instanceof DataTypeProperty) 
		 dataTypeProperty = (DataTypeProperty) data;
	
	String returnType = dataTypeProperty != null ? dataTypeProperty.getType() : refProperty.getType();
	if(returnType.contains("[[")) {
		returnType = OOABLUtil.getDisplayTypeName(returnType);
	}
	StringBuilder returnBuf = new StringBuilder();
	if (returnType != null && (returnType.indexOf('[') > 0 || returnType.indexOf('<') > 0)) {
		returnBuf.append("\"");
	}
	returnBuf.append(returnType);
	
	if (returnType != null && (returnType.indexOf('[') > 0 || returnType.indexOf('<') > 0)) {
		returnBuf.append("\"");
	}
 
     if(generateComments){
    stringBuffer.append(TemplateHelper.GeneratePropertyComment(NL));
    stringBuffer.append( NL );
    }
    stringBuffer.append(TEXT_1);
    stringBuffer.append( data.isOverride()?"OVERRIDE ":"");
    stringBuffer.append(Mode.ACESSORS[data.getMode()]);
    stringBuffer.append( data.isStatic()?" STATIC":"");
    stringBuffer.append( data.isAbstract()?" ABSTRACT":"");
    stringBuffer.append(TEXT_2);
    stringBuffer.append(data.getName());
    if(dataTypeProperty != null) {
    stringBuffer.append(TEXT_3);
    stringBuffer.append( returnBuf.toString() );
    stringBuffer.append( (data.getExtent() != 0) ? " EXTENT" : "" );
    stringBuffer.append( (data.getExtent() > 0) ? " " + String.valueOf(data.getExtent()) : "" );
    stringBuffer.append(TEXT_4);
    stringBuffer.append(dataTypeProperty.isInitial()?"INITIAL "+dataTypeProperty.getInitialValue()+" ":"" );
    stringBuffer.append(dataTypeProperty.isNoUndo()?"NO-UNDO":"");
    stringBuffer.append(TEXT_5);
    }
    else if(refProperty != null) {
    stringBuffer.append(TEXT_6);
    stringBuffer.append(OETemplateUtil.isProgressKeyWord(returnBuf.toString())?"CLASS ":"" );
    stringBuffer.append(returnBuf.toString());
    stringBuffer.append( (data.getExtent() != 0) ? " EXTENT" : "" );
    stringBuffer.append( (data.getExtent() > 0) ? " " + String.valueOf(data.getExtent()) : "" );
    stringBuffer.append(refProperty.isNoUndo()?" NO-UNDO":"");
    stringBuffer.append(TEXT_7);
    }
    if (data.isGet()) { 
    stringBuffer.append(TEXT_8);
    stringBuffer.append((data.getGetMode() < data.getMode())?Mode.ACESSORS[data.getGetMode()] + " ":"");
    if (data.isGetBody()) { 
    stringBuffer.append(TEXT_9);
    stringBuffer.append( (data.getExtent() != 0) ? "INPUT idx as INTEGER" : "" );
    stringBuffer.append(TEXT_10);
    if(data.getExtent() != 0  && !OEPreferences.getPreference(OEPreferences.P_GENERATED_PROPERTY_STYLE).equals(OEPreferences.PROPERTY_STYLE_EXCEPTIONS)) { 
		stringBuffer.append(" RETURN " + data.getName() + "[idx].");
	} else {
		if(OEPreferences.getPreference(OEPreferences.P_GENERATED_PROPERTY_STYLE).equals(OEPreferences.PROPERTY_STYLE_EXCEPTIONS)) {
			String errorMsg = "Property getter for " + data.getName() + " has not been implemented";
			stringBuffer.append("UNDO, THROW NEW Progress.Lang.AppError(\""+ errorMsg+"\").");
		}
	} 
    stringBuffer.append(TEXT_11);
     } else {
    stringBuffer.append(TEXT_12);
     } } 
     if (data.isSet())  { 
    stringBuffer.append((data.getSetMode() < data.getMode())?Mode.ACESSORS[data.getSetMode()] + " ":"");
    if (data.isSetBody()) { 
    stringBuffer.append(TEXT_13);
    stringBuffer.append( returnBuf.toString() );
    stringBuffer.append( (data.getExtent() != 0) ? ", INPUT idx as INTEGER" : "" );
    stringBuffer.append(TEXT_14);
    if(data.getExtent() != 0 && !OEPreferences.getPreference(OEPreferences.P_GENERATED_PROPERTY_STYLE).equals(OEPreferences.PROPERTY_STYLE_EXCEPTIONS)) { 
		stringBuffer.append(data.getName() + "[idx] = arg.");
	} else {
		if(OEPreferences.getPreference(OEPreferences.P_GENERATED_PROPERTY_STYLE).equals(OEPreferences.PROPERTY_STYLE_EXCEPTIONS)) {
			String errorMsg = "Property setter for " + data.getName() + " has not been implemented";
			stringBuffer.append("UNDO, THROW NEW Progress.Lang.AppError(\""+ errorMsg+"\").");
		}
	} 
    stringBuffer.append(TEXT_15);
     } else {  if (data.isGet())
    stringBuffer.append(TEXT_16);
     else 
    stringBuffer.append(TEXT_17);
    } }
    stringBuffer.append(TEXT_18);
    return stringBuffer.toString();
  }
}